class Command:
    """
    Converts the quantum gate operation into a specific command.

    Attributes:
        gate: quantum gate operator
        targets: target qubits
        controls: control qubits
        rotation: angle for rotation gate
        qasm: openqasm(2.0) string
        quqasm: qutrunk assembly format
    """
    def __init__(self, gate, targets, controls=None, rotation=None, qasm="", quqasm=""):
        if controls is None:
            # TODO:改为元组
            controls = []

        if rotation is None:
            # TODO:改为元组
            rotation = []

        self.gate = gate
        self.targets = targets
        self.controls = controls
        self.rotation = rotation
        self.qasm = qasm
        self.cmdVer = "1.0" # quqasm版本
        self.quqasm = quqasm  # 增加存放qutrunk指令对象