# todo: 1、提供quqasm指令格式导出；2、做成静态方法
class Exporter:
    """
    Convert the circuit to QASM
    """
    def __init__(self, circuit):
        self._circuit = circuit

    def dumps(self):
        """Convert the circuit to QASM 2, returning the result as a string."""
        print("OPENQASM 2.0;")
        print('include "qelib1.inc";')
        for c in self._circuit:
            print(c.qasm)

    def dump(self, file=None):
        """Convert the circuit to QASM 2, dumping the result to a file."""
        with open(file, "w") as f:
            f.write("OPENQASM 2.0;\n")
            f.write('include "qelib1.inc";\n')
            f.write(f"qreg q[{str(len(self._circuit.qreg))}];\n")
            f.write(f"creg c[{str(len(self._circuit.qreg))}];\n")
            f.write(self._circuit.get_init_qasm())
            for c in self._circuit:
                f.write(c.qasm+";\n")
