from qutrunk.core.circuit import QCircuit
from qutrunk.core.printer import Printer
from qutrunk.core.gates import H, CNOT, Measure
from qutrunk.core.backends import BackendQuSim
from qutrunk.core.exporter import Exporter
from qutrunk.core.backends import BackendIBM


def run_bell_pair(backend=None):
    # allocate
    qc = QCircuit(backend=backend)
    qr = qc.allocate(2)

    # apply gate
    H | qr[0]
    CNOT | (qr[0], qr[1])
    Measure | qr[0]
    Measure | qr[1]

    # print circuit
    Printer.print_circuit(qc)

    # run circuit
    # qc.flush()
    res = qc.run(shots=1024)

    # print result
    # print(res.get_measure())
    print(res.get_counts())
    return qc


if __name__ == "__main__":
    run_bell_pair()


