from qutrunk.core.circuit import QCircuit
from qutrunk.core.gates import CNOT, X
from qutrunk.core.counter import Counter


def run_bernstein_vazirani(backend=None):
    num_qubits = 9
    secret_num = 2 ** 4 + 1
    circuit = QCircuit(backend=backend)
    qureg = circuit.allocate(num_qubits)
    ct = Counter(circuit)

    X | qureg[0]

    bits = secret_num
    bit = 0
    for qb in range(1, num_qubits):
        bit = int(bits % 2)
        bits = int(bits / 2)
        if bit:
            CNOT | (qureg[0], qureg[qb])

    success_prob = 1.0
    bits = secret_num
    for qb in range(1, num_qubits):
        bit = int(bits % 2)
        bits = int(bits / 2)
        success_prob *= circuit.get_prob_outcome(qb, bit)

    print(f"solution reached with probability {success_prob}")

    circuit.run()
    ct.show_verbose()


if __name__ == '__main__':
    run_bernstein_vazirani()
