import numpy as np

from qutrunk.core.circuit import QCircuit
from qutrunk.core.gates import H, Measure, NOT, All, P
from qutrunk.core.backends import BackendQuSim

def run_QFT():
    circuit = QCircuit()
    qureg = circuit.allocate(3)

    All(H) | qureg
    circuit.apply_QFT([q.id for q in qureg])
    print(circuit.get_all_state())

    circuit.run()

def run_Full_QFT():
    circuit = QCircuit()
    qureg = circuit.allocate(3)

    All(H) | qureg
    circuit.apply_Full_QFT()
    print(circuit.get_all_state()) 

    circuit.run()

def qft_single_wave():
    num_qubits = 4
    circuit = QCircuit()
    qreg = circuit.allocate(num_qubits)
    All(H) | qreg
    P(np.pi/4) | qreg[0]
    P(np.pi/2) | qreg[1]
    P(np.pi) | qreg[2]
    circuit.apply_Full_QFT()
    print(circuit.get_all_state())
    circuit.run()


if __name__ == "__main__":
    # run_QFT()
    # run_Full_QFT()
    qft_single_wave()


