from qutrunk.core.circuit import QCircuit
from qutrunk.core.printer import Printer
from qutrunk.core.gates import H, Measure, All
from qutrunk.core.counter import Counter
from qutrunk.core.backends import BackendQuSim


def run_random_byte(backend=None):
    # allocate
    qc = QCircuit(backend)
    qureg = qc.allocate(8)
    # 将统计信息归集到Counter类
    ct = Counter(qc)

    All(H) | qureg
    All(Measure) | qureg

    # print circuit
    Printer.print_circuit(qc)

    # run circuit
    res = qc.run()

    # print([int(q) for q in qureg])
    print(res.get_measure())
    ct.show_verbose()


if __name__ == '__main__':
    # run_random_byte(backend=BackendQuSim())
    run_random_byte()
