# -*- coding: utf-8 -*-
# pylint: skip-file

"""Example of a simple quantum random number generator."""

from qutrunk.core.circuit import QCircuit
from qutrunk.core.printer import Printer
from qutrunk.core.gates import H, Measure, All, X, CNOT, P
# 原代码
# https://github.com/oreilly-qc/oreilly-qc.github.io/blob/master/samples/QCEngine/ch03_06_remote_random.js
# (Hadamard on first qubit, followed by CNOTs applied to all other qubits).

# create a main compiler engine

qc = QCircuit()
qureg = qc.allocate(2)

All(H) | qureg
P(45) | qureg[1]
H | qureg[1]
CNOT | (qureg[1] ,qureg[0])
All(Measure) | qureg
Printer.print_circuit(qc)
res = qc.run()
# print the result:
# print(int(qureg[0]), int(qureg[1]))
print(res.get_measure())